#include <iostream>
#include <string>

class Animal {
public:
    Animal(const std::string& name) : name_(name) {}
    void speak() const { std::cout << "Some animal sound" << std::endl; }

protected:
    std::string name_;
};

class Dog : public Animal {
public:
    using Animal::Animal;  // Inherit constructors
    void speak() const { std::cout << name_ << " says: Woof!" << std::endl; }
};

int main() {
    Dog dog("Buddy");
    dog.speak();

    return 0;
}
